package fr.aurel2108.mineboxradio;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.net.HttpURLConnection;
import java.net.URL;
import android.app.Activity;
import android.os.AsyncTask;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.TextView;
import android.widget.Toast;

public class DedicasseActivity extends Activity {
	
	Button closeButton;
	Button dedicasseButton;
	
	TextView pseudoTV;
	TextView messageTV;
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_dedicasse);
		
		closeButton = (Button) findViewById(R.id.close_button);
		dedicasseButton = (Button) findViewById(R.id.send_dedicasse);
		
		pseudoTV = (TextView) findViewById(R.id.pseudo_edit);
		messageTV = (TextView) findViewById(R.id.message_edit);
		
		closeButton.setOnClickListener(new OnClickListener() {

			@Override
			public void onClick(View arg0) {
				
				setResult(1);
			    finish();
				
			} 
		});
		
		dedicasseButton.setOnClickListener(new OnClickListener() {

			@Override
			public void onClick(View arg0) {
				
				if(!pseudoTV.getText().toString().isEmpty() && !messageTV.getText().toString().isEmpty()) {
					
					DediPostRequest request = new DediPostRequest(pseudoTV.getText().toString(), messageTV.getText().toString());
					request.execute();
					try {
						if(request.get()) {
							Toast.makeText(DedicasseActivity.this, "Ddicasse envoye !", Toast.LENGTH_LONG).show();
							pseudoTV.setText("");
							messageTV.setText("");
						}
					} catch (Exception e) {
						e.printStackTrace();
					}
					
				}
				
			} 
		});
		
	}
	
	static class DediPostRequest extends AsyncTask<Void, Void, Boolean> {

		String pseudo, message, err;
		
		public DediPostRequest(String p, String m) {
			pseudo = p;
			message = m;
		}
	
		@Override
		protected void onPostExecute(Boolean result) {

		}

		@Override
		protected Boolean doInBackground(Void... arg0) {
			try {
				HttpURLConnection connection;
			    OutputStreamWriter request = null;

			    URL url = null;        
			    String parameters = "pseudo="+pseudo+"&dedicace="+message+"&bt_dedicace=Envoyer";   

			    url = new URL("http://mineboxradio.com/MineBoxPanel/public/dedicaces.html");
			    connection = (HttpURLConnection) url.openConnection();
			    connection.setDoOutput(true);
			    connection.setRequestProperty("Content-Type", "application/x-www-form-urlencoded; charset=UTF-8");
			    connection.setRequestMethod("POST");    

			    request = new OutputStreamWriter(connection.getOutputStream());
			    request.write(parameters);
			    request.flush();
			    request.close();            
			    String line = "";               
			    InputStreamReader isr = new InputStreamReader(connection.getInputStream());
			    BufferedReader reader = new BufferedReader(isr);
			    StringBuilder sb = new StringBuilder();
			    while ((line = reader.readLine()) != null)
			    {
			    	sb.append(line + "\n");
			    }
			                // Response from server after login process will be stored in response variable.                
			    err = sb.toString();
			               // You can perform UI operations here   
			    isr.close();
			    reader.close();
			    
				return true;
			} catch (Exception e) {
				e.printStackTrace();
				return false;
			}
		}
		
	}

}
