package fr.aurel2108.mineboxradio;

import android.media.AudioManager;
import android.media.MediaPlayer;
import android.media.MediaPlayer.OnPreparedListener;
import android.os.Bundle;
import android.os.Handler;
import android.app.Activity;
import android.content.Intent;
import android.text.Html;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.ImageButton;
import android.widget.SeekBar;
import android.widget.SeekBar.OnSeekBarChangeListener;
import android.widget.TextView;
import android.widget.Toast;

public class MainActivity extends Activity {

	final String URL_radio = "http://listen.radionomy.com/minebox-radio";
	final String infoRadioURL = "http://titrage.mineboxradio.com/index.php";
	
	static MediaPlayer mediaPlayer;
	AudioManager audioManager;
	
	Handler infoHandler = new Handler();
	
	//NotificationManager notificationManager;
	
	ImageButton playButton;
	ImageButton stopButton;

	TextView radioArtistTV;
	TextView radioTitleTV;
	
	Button dedicassesButton;
	
	boolean isStopped = true;
	boolean isPaused = false;
	boolean isPlaying = false;
	
	int length = 0;
	
	//private static final int NOTIFICATION_ID = 1;
	
	//@SuppressWarnings("deprecation")
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);
		
		/*notificationManager = (NotificationManager) getSystemService(NOTIFICATION_SERVICE);
		
		if (Build.VERSION.SDK_INT > Build.VERSION_CODES.GINGERBREAD) {
			
			final Intent launchNotifiactionIntent = new Intent(this, MainActivity.class);
			final PendingIntent pendingIntent = PendingIntent.getActivity(this,
					0, launchNotifiactionIntent,
					PendingIntent.FLAG_ONE_SHOT);
		
			Notification.Builder builder = new Notification.Builder(this)
			.setWhen(System.currentTimeMillis())
			.setTicker(getResources().getString(R.string.notification))
			.setSmallIcon(R.drawable.icon)
			.setContentTitle(getResources().getString(R.string.notification_title))
			.setContentText(getResources().getString(R.string.notification_desc))
			.setContentIntent(pendingIntent);
		
			notificationManager.notify(NOTIFICATION_ID, builder.build());
		} else {
			final Intent launchNotifiactionIntent = new Intent(this, MainActivity.class);
			final PendingIntent pendingIntent = PendingIntent.getActivity(this,
					0, launchNotifiactionIntent,
					PendingIntent.FLAG_ONE_SHOT);
			
			Notification notification = new Notification(R.drawable.icon, getResources().getString(R.string.notification), System.currentTimeMillis());
			notification.setLatestEventInfo(getApplicationContext(), getResources().getString(R.string.notification_title), getResources().getString(R.string.notification_desc), pendingIntent);
		}*/
		

		playButton = (ImageButton) findViewById(R.id.play_button);
		stopButton = (ImageButton) findViewById(R.id.stop_button);
		
		radioArtistTV = (TextView) findViewById(R.id.radio_artist);
		radioTitleTV = (TextView) findViewById(R.id.radio_title);
		
		dedicassesButton = (Button) findViewById(R.id.dedicasse_button);
		
		audioManager = (AudioManager)getSystemService(MainActivity.AUDIO_SERVICE);
        audioManager.getStreamVolume(AudioManager.STREAM_MUSIC);
        int maxVolume = audioManager.getStreamMaxVolume(AudioManager.STREAM_MUSIC);
        int curVolume = audioManager.getStreamVolume(AudioManager.STREAM_MUSIC);
        SeekBar volControl = (SeekBar)findViewById(R.id.volume);
        volControl.setMax(maxVolume);
        volControl.setProgress(curVolume);
        volControl.setOnSeekBarChangeListener(new OnSeekBarChangeListener() {
								@Override
								public void onProgressChanged(SeekBar seekBar,
										int progress, boolean fromUser) {
									audioManager.setStreamVolume(AudioManager.STREAM_MUSIC, progress, 0);
									
								}
								@Override
								public void onStartTrackingTouch(SeekBar seekBar) {
									// TODO Auto-generated method stub
									
								}
								@Override
								public void onStopTrackingTouch(SeekBar seekBar) {
									// TODO Auto-generated method stub
									
								}
        });
        
        if(audioManager.isMusicActive()) {
        	playButton.setImageResource(R.drawable.pause);
        	isPaused = false;
        	isStopped = false;
        } else {
        	playButton.setImageResource(R.drawable.play);
        	isStopped = true;
        	isPaused = false;
        }
        
        playButton.setOnClickListener(new OnClickListener() {

			@Override
			public void onClick(View arg0) {
				
				if(isStopped) {
					playButton.setImageResource(R.drawable.pause);
					
            		isPaused = false;
            		isStopped = false;
            		isPlaying = true;
					
					mediaPlayer = new MediaPlayer();
					
					try {

						mediaPlayer.setDataSource(URL_radio);
					    mediaPlayer.prepareAsync();

					    mediaPlayer.start();
					    Toast.makeText(MainActivity.this, "Prparation de la radio, merci de votre patience...", Toast.LENGTH_LONG).show();
			        } catch (Exception e) {
			        	//Log.v("AUDIOHTTPPLAYER", e.getMessage());
			        }
			        
			        mediaPlayer.setOnPreparedListener(new OnPreparedListener() {
			                                   
			        	public void onPrepared(MediaPlayer mp) {
			        		
			        		mediaPlayer.start();
			            		
			            	Toast.makeText(MainActivity.this, "Lecture de la radio dbute", Toast.LENGTH_LONG).show();
			            }
					
			        } );
			        
				}
				else if(isPaused) {
					playButton.setImageResource(R.drawable.pause);
					
            		isPaused = false;
            		isStopped = false;
            		isPlaying = true;
					
					try {

						mediaPlayer.seekTo(length);
						length = 0;
					    mediaPlayer.start();
			        } catch (Exception e) {
			        	//Log.v("AUDIOHTTPPLAYER", e.getMessage());
			        }
			        
			        mediaPlayer.setOnPreparedListener(new OnPreparedListener() {
			                                   
			        	public void onPrepared(MediaPlayer mp) {
			            		mediaPlayer.start();
			            		
			            		Toast.makeText(MainActivity.this, "Lecture reprise", Toast.LENGTH_SHORT).show();
			            }
					
			        } );
				}
				else if(isPlaying) {
					
					playButton.setImageResource(R.drawable.play);
					
					isPaused = true;
            		isStopped = false;
            		isPlaying = false;
					
					length = mediaPlayer.getCurrentPosition();
					mediaPlayer.pause();
				}
				
			}
        
        });
        
        stopButton.setOnClickListener(new OnClickListener() {

			@Override
			public void onClick(View arg0) {
				
				if(isPlaying || isPaused) {
				
					playButton.setImageResource(R.drawable.play);
				
					isPaused = false;
        			isStopped = true;
	        		isPlaying = false;
					
					try {
						mediaPlayer.stop();
						mediaPlayer.reset();
						mediaPlayer.release();
						
						mediaPlayer = null;
						length = 0;
					} catch (Exception e) {
						
					}
					Toast.makeText(MainActivity.this, "Lecture de la radio arrte", Toast.LENGTH_LONG).show();
				
				}
				
			}
        
        });
        
        infoHandler.post(new Runnable(){

            @Override
            public void run() {

            	try {
                    
        	        String radioArtist, radioTitle;
        			
        	        RetrieveSiteData siteSource = new RetrieveSiteData();
        	        siteSource.execute(infoRadioURL);
        	        
        	        String infoRadioPageCode= siteSource.get();
        	        
        	        if(!infoRadioPageCode.isEmpty()) {
        	        
        		        String[] infoRadioArtist = infoRadioPageCode.split("<div id=\"artiste\"><b>Artiste : ");
        	            infoRadioArtist = infoRadioArtist[1].split("</b></div>");
        	            
        	            radioArtist = " " + Html.fromHtml(infoRadioArtist[0]).toString();
        	
        	            String[] infoRadioTitle = infoRadioPageCode.split("<div id=\"titre\">Titre : ");
        	            infoRadioTitle = infoRadioTitle[1].split("</div>");
        	            
        	            radioTitle = " " + Html.fromHtml(infoRadioTitle[0]).toString();
;
        	            radioArtistTV.setText(getResources().getString(R.string.artist) + radioArtist);
        	            radioTitleTV.setText(getResources().getString(R.string.title) + radioTitle);
        	            
        	            radioArtistTV.refreshDrawableState();
        	            radioTitleTV.refreshDrawableState();
                    
        	        }
        	        else
        	        	Toast.makeText(MainActivity.this, "no info", Toast.LENGTH_SHORT).show();

        		} catch (Exception e) {
        			// TODO Auto-generated catch block
        			e.printStackTrace();
        		}
                infoHandler.postDelayed(this,5000);

            }

        });
        
        dedicassesButton.setOnClickListener(new OnClickListener() {

			@Override
			public void onClick(View arg0) {
				
				Intent intent = new Intent(MainActivity.this, DedicasseActivity.class);
				startActivity(intent);
				
			}
			
        });
    	
	}
	
	@Override
    public boolean onCreateOptionsMenu(Menu menu) {
        getMenuInflater().inflate(R.menu.activity_main, menu);
        return true;
    }
	
	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		switch (item.getItemId()) {
		case R.id.menu_about:
			Intent intent = new Intent(MainActivity.this, AboutActivity.class);
			startActivity(intent);
			return true;
		default:
			return super.onOptionsItemSelected(item);
		}
	}
	
}